package com.tmax.openframe.file;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.dataobject.exception.EmptyResultException;
import com.tmax.proobject.dataobject.session.SessionContainer;
import java.math.*;
import java.sql.SQLException;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class COBTEST4_FD_RVL_F {
    private Long currentSeqId = null;
    private static final int DEFAULT_FETCH_SIZE = 100;
    private COBTEST4_COBTEST4_FD_RVL_F_Dof dof;
    private @Getter FileStatus fileStatus;
    private Iterator<COBTEST4_COBTEST4_FD_RVL_F_Do> forwardListIterator_COBTEST4_FD_RVL_F;

    public COBTEST4_FD_RVL_F() {
        dof = new COBTEST4_COBTEST4_FD_RVL_F_Dof();
        forwardListIterator_COBTEST4_FD_RVL_F = null;
    }

    public void start(Long key) {
        currentSeqId = key;
        dof.setSeq_Id(currentSeqId);
        dof.setFullQuery(COBTEST4_COBTEST4_FD_RVL_F_Dof.FULLQUERY.READ_GE);
        forwardListIterator_COBTEST4_FD_RVL_F = dof.getForwardList().iterator();
        if (forwardListIterator_COBTEST4_FD_RVL_F.hasNext()) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return;
        }
        fileStatus = FileStatus.NORMAL;
    }

    public COBTEST4_RVL_REC read() {
        if (fileStatus == FileStatus.AT_END_CONDITION_SEQUENCED) {
            fileStatus = FileStatus.ALREADY_AT_END_CONDITION;
            return null;
        }
        COBTEST4_COBTEST4_FD_RVL_F_Do tmp = null;
        if (forwardListIterator_COBTEST4_FD_RVL_F != null) {
            if (forwardListIterator_COBTEST4_FD_RVL_F.hasNext()) {
                tmp = forwardListIterator_COBTEST4_FD_RVL_F.next();
                currentSeqId = tmp.getSeq_Id();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        } else {
            dof.setFullQuery(COBTEST4_COBTEST4_FD_RVL_F_Dof.FULLQUERY.READ_GE);
            dof.setSeq_Id(getNextSeqId());
            forwardListIterator_COBTEST4_FD_RVL_F = dof.getForwardList()
                    .iterator();
            if (forwardListIterator_COBTEST4_FD_RVL_F.hasNext()) {
                tmp = forwardListIterator_COBTEST4_FD_RVL_F.next();
                currentSeqId = tmp.getSeq_Id();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        }
        fileStatus = FileStatus.NORMAL;
        return COBTEST4_COBTEST4_FD_RVL_F_DoToCOBTEST4_RVL_RECMapper.INSTANCE
                .toCOBTEST4_RVL_REC(tmp);
    }

    public COBTEST4_RVL_REC readNext() {
        return read();
    }

    public COBTEST4_RVL_REC readKey(Long key) {
        currentSeqId = key;
        dof.setSeq_Id(currentSeqId);
        dof.setFullQuery(COBTEST4_COBTEST4_FD_RVL_F_Dof.FULLQUERY.READ_EQ);
        forwardListIterator_COBTEST4_FD_RVL_F = dof.getForwardList().iterator();
        COBTEST4_RVL_REC record = read();
        if (record == null) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return null;
        }
        return record;
    }

    public void rewrite(COBTEST4_RVL_REC data, Long seq) {
        COBTEST4_COBTEST4_FD_RVL_F_Do tmpObject = COBTEST4_COBTEST4_FD_RVL_F_DoToCOBTEST4_RVL_RECMapper.INSTANCE
                .toCOBTEST4_COBTEST4_FD_RVL_F_Do(data);
        dof.setFullQuery(COBTEST4_COBTEST4_FD_RVL_F_Dof.FULLQUERY.REWRITE);
        tmpObject.setSeq_Id(seq);
        try {
            dof.update(tmpObject);
            fileStatus = FileStatus.NORMAL;
        } catch (EmptyResultException ex) {
            fileStatus = FileStatus.INVALID_KEY_CREATE;
        }
    }

    public void rewrite(COBTEST4_RVL_REC data) {
        rewrite(data, currentSeqId);
    }

    public void write(COBTEST4_RVL_REC data) {
        dof.setFullQuery(COBTEST4_COBTEST4_FD_RVL_F_Dof.FULLQUERY.WRITE);
        dof.add(COBTEST4_COBTEST4_FD_RVL_F_DoToCOBTEST4_RVL_RECMapper.INSTANCE
                .toCOBTEST4_COBTEST4_FD_RVL_F_Do(data));
        fileStatus = FileStatus.NORMAL;
    }

    public int delete() {
        return _delete(currentSeqId);
    }

    public int delete(Long key) {
        int cnt = _delete(key);
        if (cnt == 0) {
            fileStatus = FileStatus.INVALID_KEY_READ;
        } else {
            fileStatus = FileStatus.NORMAL;
        }
    }

    private int _delete(Long key) {
        if (dof == null || forwardListIterator_COBTEST4_FD_RVL_F == null) {
            return 0;
        }
        dof.setFullQuery(COBTEST4_COBTEST4_FD_RVL_F_Dof.FULLQUERY.DELETE);
        dof.setSeq_Id(currentSeqId);
        return dof.remove();
    }

    public void close() {
        SessionContainer.getInstance().commit();
        forwardListIterator_COBTEST4_FD_RVL_F = null;
        currentSeqId = null;
    }

    private Long getNextSeqId() {
        if (currentSeqId != null) {
            currentSeqId++;
        } else {
            currentSeqId = 1L;
        }
        return currentSeqId;
    }
}
